﻿Module Module1
    Function add_title(first_name As String, last_name As String, 
                       Optional title As String = "Mr", 
                       Optional reverse As Boolean = False) As String

        If reverse = False Then
            Return title + " " + first_name + " " + last_name
        Else
            Return title + " " + last_name + " " + first_name
        End If
    End Function

    'Main code starts here
    Sub Main()
        Console.WriteLine(add_title("John", "King"))             'It displays: Mr John King
        Console.WriteLine(add_title("Maria", "Cox", "Ms"))                    'Ms Maria Cox
        Console.WriteLine(add_title("Maria", "Cox", "Ms", True))              'Ms Cox Maria

        'Using named arguments
        Console.WriteLine(add_title("John", "King", reverse:=True))           'Mr King John
        Console.WriteLine(add_title(last_name:="Lee", first_name:="John"))    'Mr John Lee
        Console.ReadKey()
    End Sub
End Module
